<?php

class Payeer extends CPayeer {
    
    function Payeer(){
        $this->__construct(Config::$payeer_account,Config::$payeer_apiId,Config::$payeer_apiKey);
    }
    
    static public function makeHash($orderId, $amount, $currency, $desc){
        $arHash = array(
            Config::$payeer_shopId,
            $orderId,
            $amount,
            $currency,
            $desc,
            Config::$payeer_shopKey
        );
        $hash = strtoupper(hash("sha256", implode(":", $arHash)));
        return $hash;
    }
    
    static public function getBalanceRub(){
        $payeer = new Payeer();
        if($payeer->isAuth()){
            $ar_balance = $payeer->getBalance();
            return $ar_balance['balance']['RUB']['DOSTUPNO'];
        }else{
            return false;
        }
    }
    
    public function doTransfer($sum, $to, $text = "", &$error = ""){
        if($this->isAuth()){
            $arTransfer = $this->transfer(array(
                    'curIn' => 'RUB', // счет списания 
                    'sum' => $sum, // Сумма получения 
                    'curOut' => 'RUB', // валюта получения  
                    'to' => $to,
                    'comment' => $text
            ));
            if (!empty($arTransfer["historyId"])){
                    return $arTransfer["historyId"];
            }else{
                    $error = implode("; ", $arTransfer['errors']);
                    return false;
            }
        }else{
            $error = "Ошибка авторизации.";
            return false;
        }
    }
    
}
