<?php

class SMSC {

    private static function _Send(  $login,     // Логин в SMSC.RU
                                    $psw,       // Пароль или md5-hash пароля
                                    $phone,     // Номер получателя
                                    $mes,       // Текст сообщения (70 симв. - кир., 160 симв. - лат.)
                                    $id,        // Id сообщения (для хранения в БД)
                                    $sender,    // Имя отправителя
                                    $translit,  // Перевести в транслит (0 - нет, 1 - translit, 2 - mpaHC/Ium)
                                    $flash,     // Отображать сразу на экране телефона (0 - нет, 1 - да)
                                    $charset,   // Кодировка переданного сообщения (windows-1251, utf-8, koi8-r)
                                    &$out = "",
                                    &$errcode = 0,
                                    &$error = ""
                                 ) {
        $post = "login=$login&psw=$psw&phones=$phone&mes=$mes&id=$id&sender=$sender&" .
                "translit=$translit&flash=$flash&charset=$charset&fmt=1";
        if($curl = curl_init()){
            curl_setopt($curl, CURLOPT_URL, Config::$smsc_host);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $post);
            $out = curl_exec($curl);
            self::getError($out, $errcode, $error);
            curl_close($curl);
        }else{
            $errcode = 10; $error = "Ошибка библиотеки curl.";
        }
        if($errcode == 0){
            return true;
        }else{
            return false;
        }
    }
    
    public static function Send($phone,$mes,$id=0,&$out="",&$errcode=0,&$error=""){
        return self::_Send( Config::$smsc_login,
                            Config::$smsc_password,
                            $phone,
                            $mes,
                            $id,
                            Config::$smsc_sender,
                            0,
                            0,
                            "utf-8",
                            $out, $errcode, $error);
    }
    
    public static function Balance(&$errcode = 0, &$error = "", &$out = ""){
        $balance = 0;
        $post = "login=".Config::$smsc_login.
                "&psw=".Config::$smsc_password.
                "&fmt=1";
        if($curl = curl_init()){
            curl_setopt($curl, CURLOPT_URL, Config::$smsc_host_balance);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $post);
            $out = curl_exec($curl);
            curl_close($curl);
            // Error
            list($balance, $_errcode) = explode(",", $out);
            $_errcode = intval($_errcode);
            if($_errcode < 0){
                $errcode = abs($_errcode);
            }else{
                $errcode = 0;
            }
        }else{
            $errcode = 10;
        }
        switch ($errcode) {
            case 0: $error = "Баланс запрошен успешно."; break;
            case 1: $error = "Ошибка в параметрах."; break;
            case 2: $error = "Неверный логин или пароль."; break;
            case 4: $error = "IP-адрес временно заблокирован."; break;
            case 9: $error = "Попытка отправки более десяти запросов на получение баланса в течение минуты."; break;
            case 10: $error = "Ошибка библиотеки curl."; break;
        }
        return $balance;
    }
    
    private static function getError($out,&$errcode = 0, &$error = ""){
        list($id,$_errcode) = explode(",", $out);
        $_errcode = intval($_errcode);
        if($_errcode < 0){
            $errcode = abs($_errcode);
        }else{
            $errcode = 0;
        }
        switch($errcode){
            case 0: $error = "Сообщение отправлено."; break;
            case 1: $error = "Ошибка в параметрах."; break;
            case 2: $error = "Неверный логин или пароль."; break;
            case 3: $error = "Недостаточно средств на счете."; break;
            case 4: $error = "IP-адрес временно заблокирован из-за частых ошибок в запросах."; break;
            case 5: $error = "Неверный формат даты."; break;
            case 6: $error = "Сообщение запрещено (по тексту или по имени отправителя)."; break;
            case 7: $error = "Неверный формат номера телефона."; break;
            case 8: $error = "Сообщение на указанный номер не может быть доставлено."; break;
            case 9: $error = "Отправка более одного одинакового запроса на "
                    . "передачу SMS-сообщения в течение минуты."; break;
        }
        return $errcode;
    }
    
}
