<?php

//error_reporting(E_ERROR);

session_start();

header('Content-Type: text/html; charset= utf-8');

require_once 'SmartySetup.php';
require_once 'config/config.php';
require_once 'libs/cpayeer.php';
require_once 'xajax_core/xajaxAIO.inc.php';

require_once 'inc/GlobalDB.php';
require_once 'inc/Mail.php';
require_once 'inc/Marketing.php';
require_once 'inc/MySQL.php';
require_once 'inc/Payeer.php';
require_once 'inc/Phone.php';
require_once 'inc/Product.php';
require_once 'inc/Ref.php';
require_once 'inc/SMSC.php';
require_once 'inc/Transfer.php';
require_once 'inc/User.php';

if(!MySQL::Connect()){
    echo "Ошибка базы данныхgg!";
    exit;
}

$xajax = new xajax();

$xajax->registerFunction('xReg1');
$xajax->registerFunction('xReg2');
$xajax->registerFunction('xLogin');
$xajax->registerFunction('xRemind1');
$xajax->registerFunction('xRemind2');
$xajax->registerFunction('xChangePass');
$xajax->registerFunction('xExit');
$xajax->registerFunction('xDoPayment');

function xReg1($country, $phone, $secpic){
    $response = new xajaxResponse();
    $response->clear("reg_error", "innerHTML");
    $secpic = strtolower($secpic);
    if($secpic == $_SESSION['secpic']){
        if($full_phone = Phone::getPhone($country, $phone, $phone_error)){
            if(User::getFromLogin($full_phone)){
                $response->assign("secpic", "src", "secpic/secpic.php");
                $response->assign("reg_error", "innerHTML", "Пользователь с указанным номером телефона уже зарегистрирован.");
                return $response;
            }
            $_SESSION['reg_phone'] = $full_phone;
            if(Phone::setHash($full_phone, $hash)){
                if(SMSC::Send($full_phone, "Проверочный код: $hash")){
                    $response->assign("reg_info", "innerHTML", "<i>Мы отправили вам проверочный код в СМС на номер</i> +$full_phone<i>.<br>"
                        . "Введите его ниже и придумайте себе пароль.</i>");
                    $response->script("$('#reg_step1').hide(); $('#reg_step2').fadeIn(1000);");
                    return $response;
                }else{
                    $response->assign("reg_error", "innerHTML", "Ошибка отправки СМС. Повторите попытку через минуту.");
                    return $response;
                }
            }else{
                $response->assign("reg_error", "innerHTML", "Ошибка базы данныхhh.");
                return $response;
            }
        }else{
            $response->assign("reg_error", "innerHTML", $phone_error);
            return $response;
        }
    }else{
        $response->assign("reg_error", "innerHTML", "Защитный код введен неверно.");
        $response->assign("secpic", "src", "secpic/secpic.php");
        return $response;
    }
}

function xReg2($hash, $pass){
    $response = new xajaxResponse();
    $response->clear("reg_error", "innerHTML");
    if($hash == Phone::getHash($_SESSION['reg_phone'])){
        if(strlen($pass) < 6){
            $response->assign("reg_error", "innerHTML", "Пароль должен быть не короче 6 символов.");
            return $response;
        }
        if(User::Reg($_SESSION['reg_phone'], $pass, $error)){
            $response->assign("reg_info", "innerHTML", "<i>Вы успешно зарегистрировались.</i>");
            $response->script("$('#reg_step2').hide();");
            return $response;
        }else{
            $response->assign("reg_error", "innerHTML", $error);
            return $response;
        }
    }else{
        $response->assign("reg_error", "innerHTML", "Введен неправильный проверочный код.");
        return $response;
    }
}

function xLogin($country, $phone, $pass){
    $response = new xajaxResponse();
    $response->clear("login_error", "innerHTML");
    if(empty($phone) or empty($pass)){
        $response->assign("login_error", "innerHTML", "Заполните все поля.");
        return $response;
    }
    if($login = Phone::getPhone($country, $phone, $login_error)){
        if($user = User::getFromLogin($login)){
            $salt = $user->salt; $pass_hash = User::makeHash($pass, $salt);
            if($user->pass == $pass_hash){
                $_SESSION['login'] = $login;
                $_SESSION['pass'] = $pass_hash;
                $response->redirect("index.php");
                return $response;
            }else{
                $response->assign("login_error", "innerHTML", "Номер телефона или пароль указаны неверно.");
                return $response;
            }
        }else{
            $response->assign("login_error", "innerHTML", "Номер телефона или пароль указаны неверно.");
            return $response;
        }
    }else{
        $response->assign("login_error", "innerHTML", $login_error);
        return $response;
    }
}

function xRemind1($country, $phone, $secpic){
    $response = new xajaxResponse();
    $response->clear("remind_error", "innerHTML");
    $secpic = strtolower($secpic);
    if($secpic == $_SESSION['secpic']){
        if($full_phone = Phone::getPhone($country, $phone, $phone_error)){
            if(!User::getFromLogin($full_phone)){
                $response->assign("remind_secpic_img", "src", "secpic/secpic.php");
                $response->assign("remind_error", "innerHTML", "Пользователь с указанным номером телефона не зарегистрирован.");
                return $response;
            }
            $_SESSION['remind_phone'] = $full_phone;
            if(Phone::setHash($full_phone, $_hash)){
                if(SMSC::Send($full_phone, "Проверочный код: $_hash")){
                    $response->assign("remind_info", "innerHTML", "<i>Мы отправили вам проверочный код в СМС на номер</i> +$full_phone<i>.<br>"
                        . "Введите его ниже и придумайте себе пароль.</i>");
                    $response->script("$('#remind1').hide(); $('#remind2').fadeIn(1000);");
                    return $response;
                }else{
                    $response->assign("remind_error", "innerHTML", "Ошибка отправки СМС. Повторите попытку через минуту.");
                    return $response;
                }
            }else{
                $response->assign("remind_error", "innerHTML", "Ошибка базы данных.");
                return $response;
            }
        }else{
            $response->assign("remind_error", "innerHTML", $phone_error);
            return $response;
        }
    }else{
        $response->assign("remind_error", "innerHTML", "Защитный код введен неверно.");
        $response->assign("remind_secpic_img", "src", "secpic/secpic.php");
        return $response;
    }
}

function xRemind2($hash, $pass){
    $response = new xajaxResponse();
    $response->clear("remind_error", "innerHTML");
    if($hash == Phone::getHash($_SESSION['remind_phone'])){
        if(strlen($pass) < 6){
            $response->assign("remind_error", "innerHTML", "Пароль должен быть не короче 6 символов.");
            return $response;
        }
        if($user = User::getFromLogin($_SESSION['remind_phone'])){
            $user->pass = User::makeHash($pass, $user->salt);
            $response->assign("remind_info", "innerHTML", "Пароль успешно изменен.");
            $response->script("$('#remind2').hide();");
            return $response;
        }else{
            $response->assign("remind_error", "innerHTML", "Пользователь с указанным номером телефона не зарегестрирован.");
            return $response;
        }
    }else{
        $response->assign("remind_error", "innerHTML", "Введен неправильный проверочный код.");
        return $response;
    }
}

function xChangePass($userPk,$new_pass){
    $r = new xajaxResponse();
    $r->clear("changepass_info", "innerHTML");
    $r->clear("changepass_error", "innerHTML");
    if(strlen($new_pass) >= 6){
        $user = new User($userPk);
        $new_hash = User::makeHash($new_pass, $user->salt);
        $user->pass = $new_hash;
        $_SESSION['pass'] = $new_hash;
        $r->assign("changepass_info", "innerHTML", "Пароль успешно изменен.");
        $r->clear("changepass_newpass", "value");
    }else{
        $r->assign("changepass_error", "innerHTML", "Пароль должен быть не короче 6 символов.");
    }
    return $r;
}

function xExit(){
    $r = new xajaxResponse();
    session_destroy();
    $r->redirect("index.php");
    return $r;
}

function xDoPayment($userPk, $amount){
    $amount = intval($amount);
    $r = new xajaxResponse();
    $user = new User($userPk);
    $r->clear("products_error", "innerHTML");
    if($user->countUnpaidProduct() < 5){
        if($amount < 1 or $amount > 1000){
            $r->assign("products_error", "innerHTML", "Сумма должна быть от 100<span class='rub'></span> до 1000<span class='rub'></span>");
            return $r;
        }
        if($product = Product::Make($userPk, $amount)){
            $r->redirect($product->getPaidUrl());
        }else{
            $r->assign("products_error", "innerHTML", "Неизвестная ошибка. Повторите через минуту.");
        }
    }else{
        $r->assign("products_error", "innerHTML", "У вас не может быть более пяти неоплаченных вкладов.");
    }
    
    return $r;
}

$xajax->processRequest();

$smarty = new Smarty_Cashbot();

//** раскомментируйте следующую строку для отображения отладочной консоли
//$smarty->debugging = true;

/** Referal **/
if(isset($_GET['r'])){
    Ref::setRef(intval($_GET['r']));
}
/*************/

/** Login **/
$login_error = false;
if(isset($_SESSION['login']) and isset($_SESSION['pass'])){
    if($user = User::getFromLogin($_SESSION['login'])){
        if($user->pass == $_SESSION['pass']){
            $_SESSION['admin_auth'] = true;
            $smarty->assign('user', $user);
            $smarty->assign('login', $_SESSION['login']);
            $smarty->assign('auth', true);
        }else{
            $login_error = true;
        }
    }else{
        $login_error = true;
    }
    if($login_error){
        session_destroy();
        header("Location: index.php");
    }
}
/***********/

$global = array();
$global['users'] = 0;
$global['products'] = 0;
$qCntUsers = "SELECT COUNT(pk) FROM user";
if($queryCntUsers = mysql_query($qCntUsers)){
    if(mysql_num_rows($queryCntUsers)){
        $R = mysql_fetch_array($queryCntUsers);
        $global['users'] = $R[0];
        $qFake = "SELECT SUM(refs) FROM marketing1";
        if($queryFake = mysql_query($qFake)){
            if(mysql_num_rows($queryFake)){
                $R = mysql_fetch_array($queryFake);
                $global['users'] += $R[0];
            }
        }
    }
}
$qCntProducts = "SELECT COUNT(pk) FROM product WHERE verification='1'";
if($queryCntProducts = mysql_query($qCntProducts)){
    if(mysql_num_rows($queryCntProducts)){
        $R = mysql_fetch_array($queryCntProducts);
        $global['products'] = $R[0];
        $qFake = "SELECT SUM(products) FROM marketing1";
        if($queryFake = mysql_query($qFake)){
            if(mysql_num_rows($queryFake)){
                $R = mysql_fetch_array($queryFake);
                $global['products'] += $R[0];
            }
        }
    }
}
$smarty->assign('global', $global);
$smarty->assign("marketingGoldRefs", Marketing::ActionGoldRef(1388260820, 1488172136));

$prod_list[1] = GlobalDB::Get("prod1");
$prod_list[2] = GlobalDB::Get("prod2");
$prod_list[3] = GlobalDB::Get("prod3");
$smarty->assign("prod_list", $prod_list);

$smarty->display('index.tpl');

$xajax->printJavascript();